Index: code/branches/presentation2/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/branches/presentation2/src/orxonox/gamestates/GSMainMenu.cc	(revision 6312)
+++ code/branches/presentation2/src/orxonox/gamestates/GSMainMenu.cc	(revision 6313)
@@ -66,4 +66,5 @@
             // Load sound
             this->ambient_ = new AmbientSound(0);
+            this->ambient_->setSyncMode(0x0);
         }
     }
Index: code/branches/presentation2/src/orxonox/items/MultiStateEngine.cc
===================================================================
--- code/branches/presentation2/src/orxonox/items/MultiStateEngine.cc	(revision 6312)
+++ code/branches/presentation2/src/orxonox/items/MultiStateEngine.cc	(revision 6313)
@@ -55,8 +55,16 @@
         RegisterObject(MultiStateEngine);
 
-        this->defEngineSndNormal_ = new WorldSound(this);
-        this->defEngineSndBoost_ = new WorldSound(this);
-        this->defEngineSndNormal_->setLooping(true);
-        this->defEngineSndBoost_->setLooping(true);
+        if( GameMode::isMaster() )
+        {
+            this->defEngineSndNormal_ = new WorldSound(this);
+            this->defEngineSndBoost_ = new WorldSound(this);
+            this->defEngineSndNormal_->setLooping(true);
+            this->defEngineSndBoost_->setLooping(true);
+        }
+        else
+        {
+            this->defEngineSndBoost_ = 0;
+            this->defEngineSndNormal_ = 0;
+        }
 
         this->lua_ = new LuaState();
@@ -74,6 +82,8 @@
                 for (std::vector<WorldEntity*>::const_iterator it2 = (*it)->getEffectsBegin(); it2 != (*it)->getEffectsBegin(); ++it2)
                     (*it2)->destroy();
-            delete this->defEngineSndNormal_;
-            delete this->defEngineSndBoost_;
+            if( this->defEngineSndNormal_ )
+                delete this->defEngineSndNormal_;
+            if( this->defEngineSndBoost_  )
+                delete this->defEngineSndBoost_;
             delete this->lua_;
         }
@@ -97,5 +107,6 @@
         if (this->getShip())
         {
-            if (this->getShip()->hasLocalController())
+//             if (this->getShip()->hasLocalController())
+            if (GameMode::isMaster() && this->getShip()->hasLocalController())
             {
                 this->setSyncMode(ObjectDirection::Bidirectional);
@@ -192,6 +203,8 @@
             return;
 
-        this->getShip()->attach(defEngineSndNormal_);
-        this->getShip()->attach(defEngineSndBoost_);
+        if( this->defEngineSndNormal_ )
+            this->getShip()->attach(defEngineSndNormal_);
+        if( this->defEngineSndBoost_ )
+            this->getShip()->attach(defEngineSndBoost_);
 
         for (std::vector<EffectContainer*>::const_iterator it = this->effectContainers_.begin(); it != this->effectContainers_.end(); ++it)
@@ -226,20 +239,34 @@
     void MultiStateEngine::setDefEngSndNormal(const std::string &engineSound)
     {
-        defEngineSndNormal_->setSource(engineSound);
+        if( defEngineSndNormal_ )
+            defEngineSndNormal_->setSource(engineSound);
+        else
+            assert(0); // This should never happen, because soundpointer is only available on master
     }
 
     const std::string& MultiStateEngine::getDefEngSndNormal()
     {
-        return defEngineSndNormal_->getSource();
+        if( defEngineSndNormal_ )
+            return defEngineSndNormal_->getSource();
+        else
+            assert(0);
+        return std::string();
     }
 
     void MultiStateEngine::setDefEngSndBoost(const std::string &engineSound)
     {
-        defEngineSndBoost_->setSource(engineSound);
+        if( defEngineSndBoost_ )
+            defEngineSndBoost_->setSource(engineSound);
+        else
+            assert(0);
     }
 
     const std::string& MultiStateEngine::getDefEngSndBoost()
     {
-        return defEngineSndBoost_->getSource();
+        if( this->defEngineSndBoost_ )
+            return defEngineSndBoost_->getSource();
+        else
+            assert(0);
+        return std::string();
     }
 }