Index: branches/network/src/lib/network/converter.cc
===================================================================
--- branches/network/src/lib/network/converter.cc	(revision 6325)
+++ branches/network/src/lib/network/converter.cc	(revision 6326)
@@ -461,5 +461,5 @@
  * @return: the number of read bytes in byte array
  */
-int Converter::byteArrayToStringM( const byte * a, char * & s )
+int Converter::byteArrayToStringM( const byte * a, char*& s )
 {
   int length;
Index: branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- branches/network/src/lib/network/network_game_manager.cc	(revision 6325)
+++ branches/network/src/lib/network/network_game_manager.cc	(revision 6326)
@@ -384,5 +384,5 @@
 
   // -2 because you must not send network_game_manager and handshake
-  if ( !writeToClientBuffer( outBuffer[userID], networkStream->getSyncCount()-2 ) )
+  if ( !writeToClientBuffer( outBuffer[userID], networkStream->getSyncCount() ) )
     return;
 
@@ -391,21 +391,19 @@
   while ( it != e )
   {
-    if ( (*it)->getLeafID() != CL_NETWORK_GAME_MANAGER && (*it)->getLeafID() != CL_HANDSHAKE )
-    {
-
-      if ( !writeToClientBuffer( outBuffer[userID], (int)((*it)->getLeafID()) ) )
-        return;
-
+
+    if ( !writeToClientBuffer( outBuffer[userID], (int)((*it)->getLeafID()) ) )
+      return;
       //PRINTF(0)("SendEntityList: ClassID = %x\n", (*it)->getRealClassID());
 
-      if ( !writeToClientBuffer( outBuffer[userID], (int)((*it)->getUniqueID()) ) )
-        return;
-
-      if ( !writeToClientBuffer( outBuffer[userID], (int)((*it)->getOwner()) ) )
-        return;
-    }
+    if ( !writeToClientBuffer( outBuffer[userID], (int)((*it)->getUniqueID()) ) )
+      return;
+
+    if ( !writeToClientBuffer( outBuffer[userID], (int)((*it)->getOwner()) ) )
+      return;
 
     it++;
   }
+
+
 }
 
@@ -695,5 +693,6 @@
     i += Converter::byteArrayToInt( &data[i], &owner );
 
-    doCreateEntity( (ClassID)classID, uniqueID, owner );
+    if ( classID != CL_NETWORK_GAME_MANAGER && classID != CL_HANDSHAKE )
+      doCreateEntity( (ClassID)classID, uniqueID, owner );
 
   }
Index: branches/network/src/lib/network/network_stream.cc
===================================================================
--- branches/network/src/lib/network/network_stream.cc	(revision 6325)
+++ branches/network/src/lib/network/network_stream.cc	(revision 6326)
@@ -233,10 +233,10 @@
         if ( header->synchronizeableID < this->maxConnections+2 )
         {
-          if ( !isServer() ) PRINTF(0)("RESET UNIQUEID FROM %d TO 0 maxCon=%d\n", header->synchronizeableID, this->maxConnections);
+          //if ( !isServer() ) PRINTF(0)("RESET UNIQUEID FROM %d TO 0 maxCon=%d\n", header->synchronizeableID, this->maxConnections);
           header->synchronizeableID = 0;
         }
         else
         {
-          if ( !isServer() ) PRINTF(0)("UNIQUEID=%d\n", header->synchronizeableID);
+          //if ( !isServer() ) PRINTF(0)("UNIQUEID=%d\n", header->synchronizeableID);
         }
 
Index: branches/network/src/lib/sound/sound_engine.cc
===================================================================
--- branches/network/src/lib/sound/sound_engine.cc	(revision 6325)
+++ branches/network/src/lib/sound/sound_engine.cc	(revision 6326)
@@ -288,5 +288,5 @@
   // INITIALIZING THE DEVICE:
 
-#ifdef AL_VERSION_1_1
+#ifndef AL_VERSION_1_1
   ALCchar deviceName[] =
 
Index: branches/network/src/world_entities/skybox.cc
===================================================================
--- branches/network/src/world_entities/skybox.cc	(revision 6325)
+++ branches/network/src/world_entities/skybox.cc	(revision 6326)
@@ -218,15 +218,12 @@
   setIsOutOfSync( false );
 
-  /*int flsize = Converter::byteArrayToFloat( data, &size );
-  Converter::byteArrayToString( data+flsize, textureName, length-flsize );*/
-
   SYNCHELP_READ_BEGIN();
-  SYNCHELP_READ_FLOAT(size);
+  SYNCHELP_READ_FLOAT( size );
   SYNCHELP_READ_STRING( textureName, 1024 );
 
-  //PRINT(0)("GOT DATA: size=%f texture=%s\n", size, textureName);
+  PRINT(0)("GOT DATA: size=%f texture='%s'\n", size, textureName);
 
   this->setSize( size );
-  this->setTexture( textureName );
+  this->setTextureAndType( textureName, "jpg" );
   this->rebuild();
 }
@@ -245,4 +242,5 @@
   if ( rec > 0 )
   {
+    PRINT(0)("SEND DATA: size=%f texture='%s'\n", size, textureName);
     *reciever = rec;
 
Index: branches/network/src/world_entities/world_entity.cc
===================================================================
--- branches/network/src/world_entities/world_entity.cc	(revision 6325)
+++ branches/network/src/world_entities/world_entity.cc	(revision 6326)
@@ -349,5 +349,5 @@
     loadModel( modelFileName );
   }
-  delete[] modelFileName;
+  //delete []modelFileName;
 }
 