Index: code/branches/presentation2/data/gui/layouts/DecisionPopup.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/DecisionPopup.layout	(revision 6334)
+++ code/branches/presentation2/data/gui/layouts/DecisionPopup.layout	(revision 6335)
@@ -1,79 +1,40 @@
 <?xml version="1.0" encoding="UTF-8"?>
 
-
-
 <GUILayout >
-
     <Window Type="DefaultWindow" Name="orxonox/DecisionPopup_RootWindow" >
-
         <Property Name="InheritsAlpha" Value="False" />
-
         <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
         <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-
         <Window Type="TaharezLook/StaticImage" Name="orxonox/DecisionPopup_Background" >
-
-            <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
+            <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" /
             <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-
             <Property Name="Alpha" Value="0.6" />
-
             <Window Type="TaharezLook/Button" Name="orxonox/DecisionPopup_button_yes" >
-
                 <Property Name="Font" Value="BlueHighway-12" />
-
                 <Property Name="Text" Value="Yes" />
-
                 <Property Name="Alpha" Value="0.7" />
-
                 <Property Name="InheritsAlpha" Value="False" />
- 
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
                 <Property Name="UnifiedAreaRect" Value="{{0.2875,0},{0.5625,0},{0.4875,0},{0.6125,0}}" />
-
                 <Event Name="Clicked" Function="DecisionPopup.button_yes"/>
-
             </Window>
-
             <Window Type="TaharezLook/Button" Name="orxonox/DecisionPopup_button_no" >
-
                 <Property Name="Font" Value="BlueHighway-12" />
-
                 <Property Name="Text" Value="No" />
-
                 <Property Name="Alpha" Value="0.8" />
-
                 <Property Name="InheritsAlpha" Value="False" />
- 
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
                 <Property Name="UnifiedAreaRect" Value="{{0.5125,0},{0.5625,0},{0.7125,0},{0.6125,0}}" />
-
                 <Event Name="Clicked" Function="DecisionPopup.button_no"/>
-
             </Window>
-
             <Window Type="TaharezLook/StaticText" Name="orxonox/DecisionPopup_text" >
-
                 <Property Name="Text" Value="Template text" />
-
                 <Property Name="HorzFormatting" Value="WordWrapCentred" />
-
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
                 <Property Name="UnifiedAreaRect" Value="{{0.25,0},{0.4375,0},{0.75,0},{0.5375,0}}" />
-
                 <Property Name="InheritsAlpha" Value="False" />
- 
                 <Property Name="Alpha" Value="0.8" />
-
             </Window>
-
         </Window>
-
     </Window>
-
 </GUILayout>
Index: code/branches/presentation2/data/gui/layouts/InGameMenu.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/InGameMenu.layout	(revision 6334)
+++ code/branches/presentation2/data/gui/layouts/InGameMenu.layout	(revision 6335)
@@ -1,81 +1,41 @@
 <?xml version="1.0" encoding="UTF-8"?>
 
-
-
 <GUILayout >
-
     <Window Type="DefaultWindow" Name="orxonox/InGameMenu_RootWindow" >
-
         <Property Name="InheritsAlpha" Value="False" />
-
         <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
         <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-
         <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_ReturnButton" >
-
             <Property Name="Font" Value="BlueHighway-12" />
-
             <Property Name="Text" Value="Return to Game" />
-
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
             <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.3625,0},{0.6,0},{0.4125,0}}" />
-
             <Property Name="Alpha" Value="0.7" />
-
             <Event Name="Clicked" Function="InGameMenu.button_return_clicked"/>
-
         </Window>
-
         <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_MainMenuButton" >
-
             <Property Name="Font" Value="BlueHighway-12" />
-
             <Property Name="Text" Value="Main Menu" />
-
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
             <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.4625,0},{0.6,0},{0.5125,0}}" />
-
             <Property Name="Alpha" Value="0.7" />
-
             <Event Name="Clicked" Function="InGameMenu.button_mainmenu_clicked"/>
-
         </Window>
-
         <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_SettingsButton" >
-
             <Property Name="Font" Value="BlueHighway-12" />
-
             <Property Name="Text" Value="Settings" />
-
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
             <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.5625,0},{0.6,0},{0.6125,0}}" />
-
             <Property Name="Alpha" Value="0.7" />
-
             <Event Name="Clicked" Function="InGameMenu.button_settings_clicked"/>
-
         </Window>
-
         <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_QuitButton" >
-
             <Property Name="Font" Value="BlueHighway-12" />
-
             <Property Name="Text" Value="Quit" />
-
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
             <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.6625,0},{0.6,0},{0.7125,0}}" />
-
             <Property Name="Alpha" Value="0.7" />
-
             <Event Name="Clicked" Function="InGameMenu.button_quit_clicked"/>
-
         </Window>
-
     </Window>
-
 </GUILayout>
Index: code/branches/presentation2/data/gui/layouts/InfoPopup.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/InfoPopup.layout	(revision 6334)
+++ code/branches/presentation2/data/gui/layouts/InfoPopup.layout	(revision 6335)
@@ -1,62 +1,32 @@
 <?xml version="1.0" encoding="UTF-8"?>
 
-
-
 <GUILayout >
-
     <Window Type="DefaultWindow" Name="orxonox/InfoPopup_RootWindow" >
-
         <Property Name="InheritsAlpha" Value="False" />
-
         <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
         <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-
         <Window Type="TaharezLook/StaticImage" Name="orxonox/InfoPopup_Background" >
-
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
             <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-
             <Property Name="Alpha" Value="0.7" />
-
             <Window Type="TaharezLook/Button" Name="orxonox/InfoPopup_close" >
-
                 <Property Name="Font" Value="BlueHighway-12" />
-
                 <Property Name="Text" Value="Close" />
-
                 <Property Name="Alpha" Value="0.7" />
-
                 <Property Name="InheritsAlpha" Value="False" />
- 
-               <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
+                <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
                 <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.5,0},{0.6,0},{0.55,0}}" />
-
                 <Event Name="Clicked" Function="InfoPopup.close"/>
-
             </Window>
-
             <Window Type="TaharezLook/StaticText" Name="orxonox/InfoPopup_text" >
-
                 <Property Name="Text" Value="Template text" />
-
                 <Property Name="TextColours" Value="FF4444FF" />
                 <Property Name="HorzFormatting" Value="WordWrapCentred" />
-
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
                 <Property Name="UnifiedAreaRect" Value="{{0.25,0},{0.375,0},{0.75,0},{0.475,0}}" />
-
                 <Property Name="InheritsAlpha" Value="False" />
- 
                <Property Name="Alpha" Value="0.8" />
-
             </Window>
-
         </Window>
-
     </Window>
-
 </GUILayout>
Index: code/branches/presentation2/data/gui/layouts/KeyBindMenu.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/KeyBindMenu.layout	(revision 6334)
+++ code/branches/presentation2/data/gui/layouts/KeyBindMenu.layout	(revision 6335)
@@ -1,84 +1,43 @@
 <?xml version="1.0" encoding="UTF-8"?>
 
-
-
 <GUILayout >
-
     <Window Type="DefaultWindow" Name="orxonox/KeyBindMenu/Background" >
-
         <Property Name="InheritsAlpha" Value="False" />
-
         <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
         <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-
         <Window Type="TaharezLook/StaticText" Name="orxonox/KeyBindWindow" >
-
             <Property Name="Text" Value="Keybindings" />
-
             <Property Name="Alpha" Value="0.8" />
-
             <Property Name="InheritsAlpha" Value="False" />
-
             <Property Name="HorzFormatting" Value="HorzCentred" />
-
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
             <Property Name="VertFormatting" Value="TopAligned" />
-
             <Property Name="UnifiedAreaRect" Value="{{0.15,0},{0.2125,0},{0.85,0},{0.6375,0}}" />
-
             <Window Type="TaharezLook/StaticText" Name="orxonox/KeyBindWrapper" >
-
                 <Property Name="TextColours" Value="FF4444FF" />
-
                 <Property Name="InheritsAlpha" Value="False" />
-
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
                 <Property Name="HorzFormatting" Value="HorzCentred" />
-
                 <Property Name="VertFormatting" Value="TopAligned" />
-
                 <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.15,0},{0.95,0},{0.92,0}}" />
-
                 <Window Type="TaharezLook/ScrollablePane" Name="orxonox/KeyBindPane" >
-
                     <Property Name="ContentArea" Value="l:0 t:0 r:0 b:0" />
-
                     <Property Name="HorzStepSize" Value="0.1" />
-
                     <Property Name="VertStepSize" Value="0.1" />
-
                     <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
                     <Property Name="HorzOverlapSize" Value="0.01" />
-
                     <Property Name="UnifiedAreaRect" Value="{{0.005,0},{0.01,0},{0.995,0},{0.99,0}}" />
-
                     <Property Name="VertOverlapSize" Value="0.01" />
-
                     <Property Name="HorzScrollPosition" Value="0" />
-
                     <Property Name="VertScrollPosition" Value="0" />
-
                 </Window>
-
             </Window>
-
         </Window>
-
         <Window Type="TaharezLook/Button" Name="orxonox/KeyBindBackButton" >
             <Property Name="Text" Value="Back" />
-
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-
             <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.6625,0},{0.6,0},{0.7125,0}}" />
-
             <Event Name="Clicked" Function="KeyBindMenu.KeyBindBackButton_clicked"/>
-
         </Window>
-
     </Window>
-
 </GUILayout>
Index: code/branches/presentation2/data/gui/scripts/InfoPopup.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/InfoPopup.lua	(revision 6334)
+++ code/branches/presentation2/data/gui/scripts/InfoPopup.lua	(revision 6335)
@@ -1,93 +1,47 @@
 -- InfoPopup.lua
-
-
 
 BasicGUI = require("BasicGUI")
 local P = BasicGUI:new() --inherit everything from the gui package
 
-
 if _REQUIREDNAME == nil then
-
     InfoPopup = P
-
 else
-
     _G[_REQUIREDNAME] = P
-
 end
 
-
-
 P.filename = "InfoPopup"
-
 P.layoutString = "InfoPopup.layout"
 
-
-
 function P:init()
-
 end
 
-
-
 function P.execute(functionPtr, arguments)
-
     if functionPtr ~= nil then
-
         if arguments ~= nil then
-
             functionPtr(arguments)
-
         else
-
             functionPtr()
-
         end
-
     end
-
 end
 
-
-
 function P.setText( text )
-
     winMgr:getWindow("orxonox/InfoPopup_text"):setText( text )
-
 end
 
-
-
 function P.setCloseButton(closeButton)
-
     close = winMgr:getWindow("orxonox/InfoPopup_close")
-
     close:setVisible(closeButton)
-
     if(not closeButton) then
-
         close:deactivate();
-
     else
-
         close:activate();
-
     end
-
 end
 
-
-
 -- events for ingamemenu
-
-
 function P.close(e)
-
     hideGUI("InfoPopup")
-
 end
 
-
-
 return P
-
Index: code/branches/presentation2/data/gui/scripts/KeyBindMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/KeyBindMenu.lua	(revision 6334)
+++ code/branches/presentation2/data/gui/scripts/KeyBindMenu.lua	(revision 6335)
@@ -1,401 +1,213 @@
 -- KeyBindMenu.lua
 
-
-
 BasicGUI = require("BasicGUI")
-
 local P = BasicGUI:new() --inherit everything from the gui package
 
-
 if _REQUIREDNAME == nil then
-
     KeyBindMenu = P
-
 else
     _G[_REQUIREDNAME] = P
-
-end
-
-
+end
 
 P.filename = "KeyBindMenu"
-
 P.layoutString = "KeyBindMenu.layout"
 
-
-
 function P:init()
 
     commandList = {}
-
     table.insert(commandList, "fire 0")
-
     table.insert(commandList, "fire 1 | unfire")
-
     table.insert(commandList, "onpress fire 2")
-
     table.insert(commandList, "scale 1 moveFrontBack")
-
     table.insert(commandList, "scale -1 moveFrontBack")
-
     table.insert(commandList, "boost")
-
     table.insert(commandList, "scale 1 moveRightLeft")
-
     table.insert(commandList, "scale -1 moveRightLeft")
-
     table.insert(commandList, "scale 1 moveUpDown")
-
     table.insert(commandList, "scale -1 moveUpDown")
-
     table.insert(commandList, "scale 1 rotateRoll")
-
     table.insert(commandList, "scale -1 rotateRoll")
-
     table.insert(commandList, "switchCamera")
-
     table.insert(commandList, "openConsole")
-
     table.insert(commandList, "OverlayGroup toggleVisibility Debug")
-
     table.insert(commandList, "OverlayGroup toggleVisibility Stats")
-
     table.insert(commandList, "mouseLook")
-
     table.insert(commandList, "pause")
 
-    
-
     nameList = {}
-
     table.insert(nameList, "Primary Fire")
-
     table.insert(nameList, "Secondary Fire")
-
     table.insert(nameList, "Fire Rocket")
-
     table.insert(nameList, "Accelerate")
-
     table.insert(nameList, "Break")
     table.insert(nameList, "Boost")
-
     table.insert(nameList, "Move Right")
-
     table.insert(nameList, "Move Left")
-
     table.insert(nameList, "Move Up")
-
     table.insert(nameList, "Move Down")
-
     table.insert(nameList, "Roll Right")
-
     table.insert(nameList, "Roll Left")
-
     table.insert(nameList, "Switch Camera")
-
     table.insert(nameList, "Open Console")
-
     table.insert(nameList, "Show Debug")
-
     table.insert(nameList, "Show Stats")
-
     table.insert(nameList, "Look Around")
-
     table.insert(nameList, "Pause")
 
-    
-
     linesList = {}
 
-
-    lineHeight = 25
+    lineHeight = 30
     commandWidth = 125
-    buttonWidth = 125
+    buttonWidth = 145
     clearWidth = 20
-    addWidth = 25
-
+    addWidth = 30
     spaceWidth = 10
 
-    
-
     P.createLines()
 
-    
-
     local funct = luaState:createLuaFunctor("KeyBindMenu.callback()")
-
     orxonox.KeyBinderManager:getInstance():registerKeybindCallback(funct)
-
-end
-
-
-
+end
 
 function P.KeyNameNiceifier(key)
-
     local name = string.sub(key, string.find(key, '%.(.*)')+1)
     local group = string.sub(key, string.find(key, '(.*)%.'))
-
     group = string.sub(group,1,string.len(group)-1)
-
     if( group == "Keys") then
-
         return "Key " .. string.sub(name, string.find(name, 'Key(.*)')+3)
-
     elseif( group == "MouseButtons") then
-
         return "Mouse " .. name
-
-    end
-
+    end
     return key
-
-end
-
-
+end
 
 function P.createLine(k)
-
     local offset = 0
-
     local line = winMgr:createWindow("DefaultWindow", "orxonox/KeyBindPane/Binding" .. k)
-
     line:setHeight(CEGUI.UDim(0, lineHeight))
-
     line:setPosition(CEGUI.UVector2(CEGUI.UDim(0, 0), CEGUI.UDim(0, lineHeight*(k-1))))
 
-    
-
     local command = winMgr:createWindow("TaharezLook/StaticText", "orxonox/KeyBindPane/Binding" .. k .. "/Command")
-
     command:setSize(CEGUI.UVector2(CEGUI.UDim(0, commandWidth), CEGUI.UDim(1, 0)))
-
     command:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0, 0)))
-
     command:setText(nameList[k])
     line:addChildWindow(command)
-
     offset = offset + commandWidth + spaceWidth
 
+    local plus = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Plus")
+    plus:setSize(CEGUI.UVector2(CEGUI.UDim(0, addWidth), CEGUI.UDim(0.7, 0)))
+    plus:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
+    plus:setText("add")
+    orxonox.KeyBinderManager:getInstance():subscribeEventHelper(plus, "Clicked", P.filename .. ".KeyBindPlus_clicked")
+    line:addChildWindow(plus)
+    offset = offset + addWidth + spaceWidth
+
+    local numButtons = orxonox.KeyBinderManager:getInstance():getCurrent():getNumberOfBindings(commandList[k]);
+    for i=0,(numButtons-1) do
+        local button = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Button" .. i)
+        button:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0.7, 0)))
+        button:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
+        local name = orxonox.KeyBinderManager:getInstance():getCurrent():getBinding(commandList[k],i)
+        name = P.KeyNameNiceifier(name)
+        button:setText(name)
+        orxonox.KeyBinderManager:getInstance():subscribeEventHelper(button, "Clicked", P.filename .. ".KeyBindButton_clicked")
+        --button:subscribeScriptedEvent("EventClicked", P.filename .. ".KeyBindButton_clicked")
+        line:addChildWindow(button)
+        offset = offset + buttonWidth
+
+        local clear = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Clear" .. i)
+        clear:setSize(CEGUI.UVector2(CEGUI.UDim(0, clearWidth), CEGUI.UDim(0.7, 0)))
+        clear:setPosition(CEGUI.UVector2(CEGUI.UDim(0, (i*(buttonWidth+clearWidth+spaceWidth)+buttonWidth)+commandWidth+clearWidth+2*spaceWidth), CEGUI.UDim(0.15, 0)))
+        clear:setText("X")
+        orxonox.KeyBinderManager:getInstance():subscribeEventHelper(clear, "Clicked", P.filename .. ".KeyBindClear_clicked")
+        line:addChildWindow(clear)
+        offset = offset + clearWidth + spaceWidth
+    end
     
-
-    local plus = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Plus")
-
-    plus:setSize(CEGUI.UVector2(CEGUI.UDim(0, addWidth), CEGUI.UDim(0.7, 0)))
-
-    plus:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
-
-    plus:setText("add")
-
-    orxonox.KeyBinderManager:getInstance():subscribeEventHelper(plus, "Clicked", P.filename .. ".KeyBindPlus_clicked")
-
-    line:addChildWindow(plus)
-
-    offset = offset + addWidth + spaceWidth
-
+    debug(0, "OFFSET: " .. offset)
+
+    line:setWidth(CEGUI.UDim(0, offset+clearWidth))
     
-
-    local numButtons = orxonox.KeyBinderManager:getInstance():getCurrent():getNumberOfBindings(commandList[k]);
-
-    for i=0,(numButtons-1) do
-
-        local button = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Button" .. i)
-
-        button:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0.7, 0)))
-
-        button:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
-
-        local name = orxonox.KeyBinderManager:getInstance():getCurrent():getBinding(commandList[k],i)
-
-        name = P.KeyNameNiceifier(name)
-
-        button:setText(name)
-
-        orxonox.KeyBinderManager:getInstance():subscribeEventHelper(button, "Clicked", P.filename .. ".KeyBindButton_clicked")
-
-        --button:subscribeScriptedEvent("EventClicked", P.filename .. ".KeyBindButton_clicked")
-
-        line:addChildWindow(button)
-
-        offset = offset + buttonWidth
-
-        
-
-        local clear = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Clear" .. i)
-
-        clear:setSize(CEGUI.UVector2(CEGUI.UDim(0, clearWidth), CEGUI.UDim(0.7, 0)))
-
-        clear:setPosition(CEGUI.UVector2(CEGUI.UDim(0, (i*(buttonWidth+clearWidth+spaceWidth)+buttonWidth)+commandWidth+clearWidth+2*spaceWidth), CEGUI.UDim(0.15, 0)))
-
-        clear:setText("X")
-
-        orxonox.KeyBinderManager:getInstance():subscribeEventHelper(clear, "Clicked", P.filename .. ".KeyBindClear_clicked")
-
-        line:addChildWindow(clear)
-
-        offset = offset + clearWidth + spaceWidth
-
-    end
-
-    
-
-    line:setWidth(CEGUI.UDim(0, offset+clearWidth))
-
-    
-
     return line
-
-end
-
-
+end
 
 function P.createLines()
-
-
     local window = winMgr:getWindow("orxonox/KeyBindPane")
 
-
     for k,v in pairs(commandList) do
-
         local line = P.createLine(k)
-
         table.insert(linesList, line)
-
         window:addChildWindow(line)
-
-    end
-
-
-end
-
-
+    end
+end
 
 function P.KeyBindButton_clicked(e)
-
     local we = CEGUI.toWindowEventArgs(e)
-
     local name = we.window:getName()
 
-
     local match = string.gmatch(name, "%d+")
-
     local commandNr = tonumber(match())
-
     local buttonNr = tonumber(match())
 
-    
-
     local arguments = {}
-
     arguments[1] = commandNr
-
     arguments[2] = buttonNr
-
     openInfoPopup("Press any button/key or move a mouse/joystick axis.", KeyBindMenu.keybind, false, arguments)
 end
 
 function P.KeyBindPlus_clicked(e)
-
     local we = CEGUI.toWindowEventArgs(e)
-
     local name = we.window:getName()
 
-    
-
     local match = string.gmatch(name, "%d+")
-
     local commandNr = tonumber(match())
-    
 
     local arguments = {}
-
     arguments[1] = commandNr
-
     openInfoPopup("Press any button/key or move a mouse/joystick axis.", KeyBindMenu.keybind, false, arguments)
 end
 
 function P.KeyBindClear_clicked(e)
-
     local we = CEGUI.toWindowEventArgs(e)
-
     local name = we.window:getName()
 
-    
-
     local match = string.gmatch(name, "%d+")
-
     local commandNr = tonumber(match())
-
     local buttonNr = tonumber(match())
-   
  
     orxonox.KeyBinderManager:getInstance():unbind(orxonox.KeyBinderManager:getInstance():getCurrent():getBinding(commandList[commandNr], buttonNr))
 
-    
-
     P.callback()
-
-end
-
-
+end
 
 function P.keybind(arguments)
-
     local commandNr = arguments[1]
-
     local buttonNr = arguments[2]
-
     if buttonNr ~= nil then
-
         orxonox.KeyBinderManager:getInstance():unbind(orxonox.KeyBinderManager:getInstance():getCurrent():getBinding(commandList[commandNr], buttonNr))
-
-    end
-
+    end
 
     orxonox.KeyBinderManager:getInstance():keybind(commandList[commandNr])
-
-end
-
-
+end
 
 function P.callback()
-
     while table.getn(linesList) ~= 0 do
-
         if linesList[1] ~= nil then
-
             winMgr:destroyWindow(linesList[1]:getName())
-
         end
-
         table.remove(linesList, 1)
-
-    end
-
-    
+    end
 
     linesList = {}
 
-
     P.createLines()
-
     if(InfoPopup ~= nil) then
-
         InfoPopup.close()
-
-    end
-
-end
-
-
+    end
+end
 
 function P.KeyBindBackButton_clicked(e)
-
     hideGUI("KeyBindMenu")
-
-end
-
-
+end
 
 return P
-